% script to run cross correlation between t1 and t2, and find time difference
function diff = func_findtimedifference(t1source, t2source, readepoch)
coarset=2048*8; % coarese time resolution = 2048 ns
finet=2*8;           % fine time resolution = 2ns
t1tab=func_uncompresst1(t1source,readepoch);
t2tab=func_uncompresst2(t2source,readepoch);
t1=t1tab(:,1);      % the array of timing
t2=t2tab(:,1);

off1=fix(t1(1)/(2^32)) * (2^32);
t1=t1-off1;  %array of t1 time diff refer to start point of the epoch

for i=2:length(t2)
    t2(i)=t2(i)+t2(i-1);
end      %array of time diff refer to start point of the epoch

len1=length(t1);
len2=length(t2);

nc = 2^32/coarset; % the length of the array used for cross correlation
tc1=zeros(nc,1);
tc2=zeros(nc,1);

% make an array, in which the value of the ith element represents how many
% clicks occurs between timing (i-1)*coarset and i*coarset.
for i=1:len1
    nn=ceil(t1(i)/coarset);
    tc1(nn)=tc1(nn)+1;
end
for i=1:len2
    nn=ceil(t2(i)/coarset);
    tc2(nn)=tc2(nn)+1;
end

[cco,ico]=max(xcorr(tc2,tc1)); %find the max of the cross correlation function

% make two arrays tff1 and tff2 to find time diff at fine resolution. Shift t1 (or t2) coarse time difference. Find
% a pair of bins that t1 and t2 both have non-zero value. Partition it into
% 1024 small bins. Then find the next non-zero pair of bins, partition
% into 1024 small bins and concatenate to the last found 1024 small bins.
% Until tff1 and tff2 both have 2^20 elements, which is the max length for
% cross correlation.
tt1=t1;
tt2=t2;
ttt1=[];
ttt2=[];
tff1=zeros(2^20,1);
tff2=zeros(2^20,1);
in=0;
if nc>=ico
    shift=nc-ico;
    for ii=1:ico
        if tc1(ii+shift)*tc2(ii)~=0
            if in<1024
                stim=(ii+shift-1)*coarset;
                etim=min(max(tt1),(ii+shift)*coarset+1);
                iii=1;
                while tt1(iii)<=stim
                    iii=iii+1;
                end                
                tt1(1:iii-1)=[];               
                iii=1;
                while tt1(iii)<etim
                    iii=iii+1;
                end                
                ttt1=tt1(1:iii-1);
                tt1(1:iii-1)=[];             
                for iiii=1:length(ttt1)            
                    nnn= ceil ( mod(ttt1(iiii), coarset) / finet );          
                    tff1(in*1024+nnn)=tff1(in*1024+nnn)+1;
                end
                stim=(ii-1)*coarset;
                etim=min(max(tt2),ii*coarset+1);
                iii=1;
                while tt2(iii)<=stim
                    iii=iii+1;
                end                
                tt2(1:iii-1)=[];               
                iii=1;
                while tt2(iii)<etim
                    iii=iii+1;
                end                
                ttt2=tt2(1:iii-1);
                tt2(1:iii-1)=[];             
                for iiii=1:length(ttt2)            
                    nnn= ceil ( mod(ttt2(iiii), coarset) / finet );          
                    tff2(in*1024+nnn)=tff2(in*1024+nnn)+1;
                end
                in=in+1;
            end
        end
    end
else
    shift=ico-nc;
    for ii=1:2*nc-ico
        if tc2(ii+shift)*tc1(ii)~=0
            if in<1024
                stim=(ii+shift-1)*coarset;
                etim=min(max(tt2),(ii+shift)*coarset+1);
                iii=1;
                while tt2(iii)<=stim
                    iii=iii+1;
                end                
                tt2(1:iii-1)=[];               
                iii=1;
                while tt2(iii)<etim
                    iii=iii+1;
                end                
                ttt2=tt2(1:iii-1);
                tt2(1:iii-1)=[];             
                for iiii=1:length(ttt2)            
                    nnn= ceil ( mod(ttt2(iiii), coarset) / finet );          
                    tff2(in*1024+nnn)=tff2(in*1024+nnn)+1;
                end
                stim=(ii-1)*coarset;
                etim=min(max(tt1),ii*coarset+1);
                iii=1;
                while tt1(iii)<=stim
                    iii=iii+1;
                end                
                tt1(1:iii-1)=[];               
                iii=1;
                while tt1(iii)<etim
                    iii=iii+1;
                end                
                ttt1=tt1(1:iii-1);
                tt1(1:iii-1)=[];             
                for iiii=1:length(ttt1)            
                    nnn= ceil ( mod(ttt1(iiii), coarset) / finet );          
                    tff1(in*1024+nnn)=tff1(in*1024+nnn)+1;
                end
                in=in+1;
            end
        end
    end
end             

[cfi,ifi]=max(xcorr(tff2,tff1));    % find the max of the cross correlation

% combine coarse and fine time difference.
if nc>=ico
    diff=(shift*coarset+(2^20-ifi)*finet)/8; 
else
    diff=-(shift*coarset+(2^20-ifi)*finet)/8;
end
end