% script of the function to uncompress t1 file to a Nx2 matrix. First colume is timing and second column is bitvalue. 

function t1tab = func_uncompresst1 (t1basedir, readepoch) % define the function to read an epoch from the dir
t1file = fopen(strcat(t1basedir,readepoch));
data = fread(t1file,'uint32');
fclose(t1file); % read an epoch

length = data(3); % so many clicks in the epoch
numbits= data(4); % timing, normally 49 bits
basebits = data(5); % bit value, normall 4 bits
t1tab = zeros(length,2); % initialize a matrix to store the result
i=1; % pointer to every click.  It also pointed to each element in t1tab.

for i=1:length
    ii = i*2+4; % a pair of 32-bit-wide-integers recorded an event. ii is pointed the first integer of each pair. Start from the 6th integer.
    iii=ii+1; 
    bit = mod(data(iii),16); % the last 4 bits of the second integer in each pair are the bit value
    tim = data(ii)*(2^17)+fix(data(iii)/(2^15)); % the first 49 bits in each pair are the timing
    t1tab(i,1)=tim;
    t1tab(i,2)=bit;
    i=i+1;
end

end